<?php

namespace Ems\Controllers;

use Ems\Services\HierarquiaService;
use Ems\Util\ExpectedException;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class HierarquiaController {

    public function __construct(
        HierarquiaService $hierarquiaService
    ) {
        $this->hierarquiaService = $hierarquiaService;
    }

    public function getTiposHierarquia(
        DTO\Request\Row $request,
        DTO\Response $response
    ) {
        try {
            $tiposHierarquia = $this->hierarquiaService->getTiposHierarquia();

            $response->addDataSet(new DataSet('getTiposHierarquia', $tiposHierarquia));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}