<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class ValeTransporteRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function setValeTransporte(
        array $params
    ): void {
        $sql = <<<SQL
            INSERT INTO VAB_LINHAVINC (
                NRLINHAVINC,        NRLINHATARIFA,      NRVINCULOM,
                NRTIPOLINHAVINC,    NRSENTIDOLINHA,     DTINILINHAVINC,
                DTFIMLINHAVINC,     QTLINHATARIFA,      DSOBSLINHAVINC,
                IDATIVO,            NRORGINCLUSAO,      DTINCLUSAO,
                CDOPERINCLUSAO,     NRORGULTATU,        DTULTATU,
                CDOPERULTATU,       NRORG,              NRINTEGTRANSPM
            )
            VALUES (
                :NRLINHAVINC,       :NRLINHATARIFA,     :NRVINCULOM,
                :NRTIPOLINHAVINC,   :NRSENTIDOLINHA,    :DTINILINHAVINC,
                :DTFIMLINHAVINC,    :QTLINHATARIFA,     :DSOBSLINHAVINC,
                :IDATIVO,           :NRORGINCLUSAO,     :DTINCLUSAO,
                :CDOPERINCLUSAO,    :NRORGULTATU,       :DTULTATU,
                :CDOPERULTATU,      :NRORG,             :NRINTEGTRANSPM
            )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}