CREATE OR REPLACE
PROCEDURE ARQUIVO_DIMESC_CONTABIL(
  P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
  P_DTREFCTB    IN SALDEMPR.DTSALDEMPR%TYPE,
  P_ATIVO       IN TIPODEMO.CDTIPODEMO%TYPE,
  P_PASSIVO     IN TIPODEMO.CDTIPODEMO%TYPE,
  P_DRE         IN TIPODEMO.CDTIPODEMO%TYPE,
  P_DESPESAS    IN TIPODEMO.CDTIPODEMO%TYPE,
  P_TOTARQ      IN INTEGER,
  P_TOTALARQ    OUT NUMBER,
  P_CONTADOR    OUT NUMBER,
  P_NRSEQARQMAG IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
IS
  V_CONTADOR   INTEGER;
  V_TOTARQUIVO INTEGER;
  V_DSLINHA    VARCHAR2(500);
  V_CONTADORS  VARCHAR(10);
  V_TPVALOR    VARCHAR(1);
  V_VRITEM     FLOAT;
  V_PRIMVEZ    VARCHAR(1);
BEGIN
   V_CONTADOR   := 84;
   V_TOTARQUIVO := P_TOTARQ;
   FOR ATIVO IN
       (SELECT IT.CDITEMSTRU, IT.IDOPERACAO, IT.CDTIPODEMO
         FROM ITEMDEMOF IT
        WHERE IT.IDORIGVALOR = 'A'
          AND IT.CDTIPODEMO  = P_ATIVO
        ORDER BY CDITEMSTRU) LOOP
           BEGIN
              SELECT DISTINCT IDTIPOORIG
                INTO V_TPVALOR
                FROM ITEMAPUCTB T
               WHERE CDTIPODEMO = ATIVO.CDTIPODEMO
                 AND CDITEMSTRU = ATIVO.CDITEMSTRU;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
                 V_TPVALOR := NULL;
           END;
           V_VRITEM  := 0;
           V_PRIMVEZ := 'S';
           IF V_TPVALOR = 'S' THEN
              FOR C_APURACAO IN
                 (SELECT NVL(SUM(VRSALDEMPR), 0) VALOR
                    FROM SALDEMPR S, ITEMAPUCTB I
                   WHERE S.CDEMPRESA  = P_CDEMPRESA
                     AND S.CDCONTCTBL = I.CDORIGDEMO
                     AND S.DTSALDEMPR = P_DTREFCTB
                     AND I.CDTIPODEMO = ATIVO.CDTIPODEMO
                     AND I.CDITEMSTRU = ATIVO.CDITEMSTRU) LOOP
                     IF ATIVO.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                        V_VRITEM := V_VRITEM + C_APURACAO.VALOR;
                     ELSIF ATIVO.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                        IF V_PRIMVEZ = 'S' THEN
                           V_VRITEM  := C_APURACAO.VALOR;
                           V_PRIMVEZ := 'N';
                        ELSE
                           V_VRITEM  := V_VRITEM - C_APURACAO.VALOR;
                        END IF;
                     ELSIF ATIVO.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                        IF V_PRIMVEZ = 'S' THEN
                           V_VRITEM  := 1;
                           V_PRIMVEZ := 'N';
                        END IF;
                        V_VRITEM := V_VRITEM * C_APURACAO.VALOR;
                     ELSIF ATIVO.IDOPERACAO = 'D' THEN      -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                        IF V_PRIMVEZ = 'S' THEN             -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                           V_VRITEM := C_APURACAO.VALOR;
                           V_PRIMVEZ := 'N';
                        ELSE
                           IF C_APURACAO.VALOR = 0 THEN
                              V_VRITEM := V_VRITEM / 1;
                           ELSE
                              V_VRITEM := V_VRITEM / C_APURACAO.VALOR; -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                           END IF;
                        END IF;
                     END IF;
              END LOOP;
              SELECT '8181' || SUBSTR(ATIVO.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
                INTO V_DSLINHA
                FROM DUAL;
              IF V_VRITEM <> 0 THEN
                 V_CONTADOR  := V_CONTADOR + 1;
                 V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
                 INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                 VALUES
                   (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
                 V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
              END IF;
           ELSE
              FOR C_APURACAO IN
                 (SELECT SUBSTR(CDORIGDEMO, 4, 3) CDORIGDEMO
                    FROM ITEMAPUCTB
                   WHERE CDTIPODEMO = ATIVO.CDTIPODEMO
                     AND CDITEMSTRU = ATIVO.CDITEMSTRU
                   ORDER BY CDSEGUAPUR)LOOP
                   FOR C_VALORITEM IN
                   (SELECT TO_NUMBER(SUBSTR(A.DSREGARQMAG, 8, 15) || ',' || SUBSTR(A.DSREGARQMAG, 23, 2)) * TO_NUMBER(SUBSTR(A.DSREGARQMAG, 25, 2)) VALOR
                      FROM ARQMAGNETICO A
                     WHERE NRSEQARQMAG = P_NRSEQARQMAG
                       AND SUBSTR(DSREGARQMAG, 1, 4) = '8181'
                       AND SUBSTR(DSREGARQMAG, 5, 3) = C_APURACAO.CDORIGDEMO) LOOP
                       IF ATIVO.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                          V_VRITEM := V_VRITEM + C_VALORITEM.VALOR;
                       ELSIF ATIVO.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                          IF V_PRIMVEZ = 'S' THEN
                             V_VRITEM  := C_VALORITEM.VALOR;
                             V_PRIMVEZ := 'N';
                          ELSE
                             V_VRITEM  := V_VRITEM - C_VALORITEM.VALOR;
                          END IF;
                       ELSIF ATIVO.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                          IF V_PRIMVEZ = 'S' THEN
                             V_VRITEM  := 1;
                             V_PRIMVEZ := 'N';
                          END IF;
                          V_VRITEM := V_VRITEM * C_VALORITEM.VALOR;
                       ELSIF ATIVO.IDOPERACAO = 'D' THEN        -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                          IF V_PRIMVEZ = 'S' THEN               -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                             V_VRITEM := C_VALORITEM.VALOR;
                             V_PRIMVEZ := 'N';
                          ELSE
                             IF C_VALORITEM.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                                V_VRITEM := V_VRITEM / 1;
                             ELSE
                                V_VRITEM := V_VRITEM / C_VALORITEM.VALOR;
                             END IF;
                          END IF;
                       END IF;
                   END LOOP;
              END LOOP;
              SELECT '8181' || SUBSTR(ATIVO.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
                INTO V_DSLINHA
                FROM DUAL;
              IF V_VRITEM <> 0 THEN
                 V_CONTADOR  := V_CONTADOR + 1;
                 V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
                 INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                 VALUES
                   (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
                 V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
              END IF;
           END IF;
   END LOOP;
   FOR PASSIVO IN
      (SELECT IT.CDITEMSTRU, IT.IDOPERACAO, IT.CDTIPODEMO
         FROM ITEMDEMOF IT
        WHERE IT.IDORIGVALOR = 'A'
          AND IT.CDTIPODEMO  = P_PASSIVO
        ORDER BY CDITEMSTRU) LOOP
        BEGIN
           SELECT DISTINCT IDTIPOORIG
             INTO V_TPVALOR
             FROM ITEMAPUCTB T
            WHERE CDTIPODEMO = PASSIVO.CDTIPODEMO
              AND CDITEMSTRU = PASSIVO.CDITEMSTRU;
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_TPVALOR := NULL;
        END;
        V_VRITEM  := 0;
        V_PRIMVEZ := 'S';
        IF V_TPVALOR = 'S' THEN
           FOR C_APURACAO IN
              (SELECT NVL(SUM(VRSALDEMPR), 0) VALOR
                 FROM SALDEMPR S, ITEMAPUCTB I
                WHERE S.CDEMPRESA  = P_CDEMPRESA
                  AND S.CDCONTCTBL = I.CDORIGDEMO
                  AND S.DTSALDEMPR = P_DTREFCTB
                  AND I.CDTIPODEMO = PASSIVO.CDTIPODEMO
                  AND I.CDITEMSTRU = PASSIVO.CDITEMSTRU) LOOP
                  IF PASSIVO.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     V_VRITEM := V_VRITEM + C_APURACAO.VALOR;
                  ELSIF PASSIVO.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN
                        V_VRITEM  := C_APURACAO.VALOR;
                        V_PRIMVEZ := 'N';
                     ELSE
                        V_VRITEM  := V_VRITEM - C_APURACAO.VALOR;
                     END IF;
                  ELSIF PASSIVO.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN
                        V_VRITEM  := 1;
                        V_PRIMVEZ := 'N';
                     END IF;
                     V_VRITEM := V_VRITEM * C_APURACAO.VALOR;
                  ELSIF PASSIVO.IDOPERACAO = 'D' THEN        -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN                 -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                        V_VRITEM := C_APURACAO.VALOR;
                        V_PRIMVEZ := 'N';
                     ELSE
                        IF C_APURACAO.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                           V_VRITEM := V_VRITEM / 1;
                        ELSE
                           V_VRITEM := V_VRITEM / C_APURACAO.VALOR;
                        END IF;
                     END IF;
                  END IF;
           END LOOP;
           SELECT '8282' || SUBSTR(PASSIVO.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
             INTO V_DSLINHA
             FROM DUAL;
           IF V_VRITEM <> 0 THEN
              V_CONTADOR  := V_CONTADOR + 1;
              V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
              INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES
                (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
               V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
           END IF;
        ELSE
           FOR C_APURACAO IN
              (SELECT SUBSTR(CDORIGDEMO, 4, 3) CDORIGDEMO
                 FROM ITEMAPUCTB
                WHERE CDTIPODEMO = PASSIVO.CDTIPODEMO
                  AND CDITEMSTRU = PASSIVO.CDITEMSTRU
                ORDER BY CDSEGUAPUR)LOOP
                FOR C_VALORITEM IN
                (SELECT TO_NUMBER(SUBSTR(A.DSREGARQMAG, 8, 15) || ',' || SUBSTR(A.DSREGARQMAG, 23, 2)) VALOR
                   FROM ARQMAGNETICO A
                  WHERE NRSEQARQMAG = P_NRSEQARQMAG
                    AND SUBSTR(DSREGARQMAG, 1, 4) = '8282'
                    AND SUBSTR(DSREGARQMAG, 5, 3) = C_APURACAO.CDORIGDEMO) LOOP
                    IF PASSIVO.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       V_VRITEM := V_VRITEM + C_VALORITEM.VALOR;
                    ELSIF PASSIVO.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN
                          V_VRITEM  := C_VALORITEM.VALOR;
                          V_PRIMVEZ := 'N';
                       ELSE
                          V_VRITEM  := V_VRITEM - C_VALORITEM.VALOR;
                       END IF;
                    ELSIF PASSIVO.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN
                          V_VRITEM  := 1;
                          V_PRIMVEZ := 'N';
                       END IF;
                       V_VRITEM := V_VRITEM * C_VALORITEM.VALOR;
                    ELSIF PASSIVO.IDOPERACAO = 'D' THEN       -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN                -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                          V_VRITEM := C_VALORITEM.VALOR;
                          V_PRIMVEZ := 'N';
                       ELSE
                          IF C_VALORITEM.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                             V_VRITEM := V_VRITEM / 1;
                          ELSE
                             V_VRITEM := V_VRITEM / C_VALORITEM.VALOR;
                          END IF;
                       END IF;
                    END IF;
                END LOOP;
           END LOOP;
           SELECT '8282' || SUBSTR(PASSIVO.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
             INTO V_DSLINHA
             FROM DUAL;
           IF V_VRITEM <> 0 THEN
              V_CONTADOR  := V_CONTADOR + 1;
              V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
              INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES
                (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
              V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
           END IF;
        END IF;
     END LOOP;
   FOR DRE IN
      (SELECT IT.CDITEMSTRU, IT.IDOPERACAO, IT.CDTIPODEMO
         FROM ITEMDEMOF IT
        WHERE IT.IDORIGVALOR = 'A'
          AND IT.CDTIPODEMO  = P_DRE
        ORDER BY CDITEMSTRU) LOOP
        BEGIN
           SELECT DISTINCT IDTIPOORIG
             INTO V_TPVALOR
             FROM ITEMAPUCTB T
            WHERE CDTIPODEMO = DRE.CDTIPODEMO
              AND CDITEMSTRU = DRE.CDITEMSTRU;
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_TPVALOR := NULL;
        END;
        V_VRITEM  := 0;
        V_PRIMVEZ := 'S';
        IF V_TPVALOR = 'S' THEN
           FOR C_APURACAO IN
              (SELECT NVL(SUM(vrsaldotransf), 0) VALOR
                 FROM saldotransf S, ITEMAPUCTB I
                WHERE S.CDEMPRESA  = P_CDEMPRESA
                  AND S.CDCONTCTBL = I.CDORIGDEMO
                  AND S.dtsaldotransf = P_DTREFCTB
                  AND I.CDTIPODEMO = DRE.CDTIPODEMO
                  AND I.CDITEMSTRU = DRE.CDITEMSTRU) LOOP
                  IF DRE.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     V_VRITEM := V_VRITEM + C_APURACAO.VALOR;
                  ELSIF DRE.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN
                        V_VRITEM  := C_APURACAO.VALOR;
                        V_PRIMVEZ := 'N';
                     ELSE
                        V_VRITEM  := V_VRITEM - C_APURACAO.VALOR;
                     END IF;
                  ELSIF DRE.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN
                        V_VRITEM  := 1;
                        V_PRIMVEZ := 'N';
                     END IF;
                     V_VRITEM := V_VRITEM * C_APURACAO.VALOR;
                  ELSIF DRE.IDOPERACAO = 'D' THEN        -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN             -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                        V_VRITEM := C_APURACAO.VALOR;
                        V_PRIMVEZ := 'N';
                     ELSE
                        IF C_APURACAO.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                           V_VRITEM := V_VRITEM / 1;
                        ELSE
                           V_VRITEM := V_VRITEM / C_APURACAO.VALOR;
                        END IF;
                     END IF;
                  END IF;
           END LOOP;
           SELECT '8383' || SUBSTR(DRE.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
             INTO V_DSLINHA
             FROM DUAL;
              V_CONTADOR  := V_CONTADOR + 1;
              V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
              INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES
                (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
              V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
        ELSE
           FOR C_APURACAO IN
              (SELECT SUBSTR(CDORIGDEMO, 4, 3) CDORIGDEMO
                 FROM ITEMAPUCTB
                WHERE CDTIPODEMO = DRE.CDTIPODEMO
                  AND CDITEMSTRU = DRE.CDITEMSTRU
                ORDER BY CDSEGUAPUR)LOOP
                FOR C_VALORITEM IN
                (SELECT TO_NUMBER(SUBSTR(A.DSREGARQMAG, 8, 15) || ',' || SUBSTR(A.DSREGARQMAG, 23, 2)) VALOR, A.DSREGARQMAG REGISTRO
                   FROM ARQMAGNETICO A
                  WHERE NRSEQARQMAG = P_NRSEQARQMAG
                    AND SUBSTR(DSREGARQMAG, 1, 4) = '8383'
                    AND SUBSTR(DSREGARQMAG, 5, 3) = C_APURACAO.CDORIGDEMO) LOOP
                    IF DRE.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF SUBSTR(C_VALORITEM.REGISTRO, 25, 2) = '+1' THEN
                          V_VRITEM := V_VRITEM + C_VALORITEM.VALOR;
                       ELSE
                          V_VRITEM := V_VRITEM + (C_VALORITEM.VALOR * -1); 
                       END IF;          
                    ELSIF DRE.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN
                          V_VRITEM  := C_VALORITEM.VALOR;
                          V_PRIMVEZ := 'N';
                       ELSE
                          V_VRITEM  := V_VRITEM - C_VALORITEM.VALOR;
                       END IF;
                    ELSIF DRE.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN
                          V_VRITEM  := 1;
                          V_PRIMVEZ := 'N';
                       END IF;
                       V_VRITEM := V_VRITEM * C_VALORITEM.VALOR;
                    ELSIF DRE.IDOPERACAO = 'D' THEN       -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN            -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                          V_VRITEM := C_VALORITEM.VALOR;
                          V_PRIMVEZ := 'N';
                       ELSE
                          IF C_VALORITEM.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                             V_VRITEM := V_VRITEM / 1;
                          ELSE
                             V_VRITEM := V_VRITEM / C_VALORITEM.VALOR;
                          END IF;
                       END IF;
                    END IF;
                END LOOP;
           END LOOP;
           IF (SUBSTR(DRE.CDITEMSTRU, 2, 3) = '398')  AND V_VRITEM > 0 THEN
              V_VRITEM := 0;
           END IF;
           IF (SUBSTR(DRE.CDITEMSTRU, 2, 3) = '399')  AND V_VRITEM < 0 THEN
              V_VRITEM := 0;
           END IF;

           IF (SUBSTR(DRE.CDITEMSTRU, 2, 3) = '351')  AND V_VRITEM > 0 THEN
              V_VRITEM := 0;
           END IF;

           IF (SUBSTR(DRE.CDITEMSTRU, 2, 3) = '350')  AND V_VRITEM < 0 THEN
              V_VRITEM := 0;
           END IF;

           IF NOT ((SUBSTR(DRE.CDITEMSTRU, 2, 3) = '398') AND (V_VRITEM = 0)) THEN
              IF NOT ((SUBSTR(DRE.CDITEMSTRU, 2, 3) = '399') AND (V_VRITEM = 0)) THEN
                 SELECT '8383' || SUBSTR(DRE.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
                   INTO V_DSLINHA
                   FROM DUAL;

                 V_CONTADOR  := V_CONTADOR + 1;
                 V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
                 INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                 VALUES
                   (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
                 V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
              END IF;
           END IF;
        END IF;
     END LOOP;
   FOR DESP IN
      (SELECT IT.CDITEMSTRU, IT.IDOPERACAO, IT.CDTIPODEMO
         FROM ITEMDEMOF IT
        WHERE IT.IDORIGVALOR = 'A'
          AND IT.CDTIPODEMO  = P_DESPESAS
        ORDER BY CDITEMSTRU) LOOP
        BEGIN
           SELECT DISTINCT IDTIPOORIG
             INTO V_TPVALOR
             FROM ITEMAPUCTB T
            WHERE CDTIPODEMO = DESP.CDTIPODEMO
              AND CDITEMSTRU = DESP.CDITEMSTRU;
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_TPVALOR := NULL;
        END;
        V_VRITEM  := 0;
        V_PRIMVEZ := 'S';
        IF V_TPVALOR = 'S' THEN
           FOR C_APURACAO IN
              (SELECT NVL(SUM(vrsaldotransf), 0) VALOR
                 FROM saldotransf S, ITEMAPUCTB I
                WHERE S.CDEMPRESA  = P_CDEMPRESA
                  AND S.CDCONTCTBL = I.CDORIGDEMO
                  AND S.dtsaldotransf = P_DTREFCTB
                  AND I.CDTIPODEMO = DESP.CDTIPODEMO
                  AND I.CDITEMSTRU = DESP.CDITEMSTRU) LOOP
                  IF DESP.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     V_VRITEM := V_VRITEM + C_APURACAO.VALOR;
                  ELSIF DESP.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN
                        V_VRITEM  := C_APURACAO.VALOR;
                        V_PRIMVEZ := 'N';
                     ELSE
                        V_VRITEM  := V_VRITEM - C_APURACAO.VALOR;
                     END IF;
                  ELSIF DESP.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN
                        V_VRITEM  := 1;
                        V_PRIMVEZ := 'N';
                     END IF;
                     V_VRITEM := V_VRITEM * C_APURACAO.VALOR;
                  ELSIF DESP.IDOPERACAO = 'D' THEN        -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                     IF V_PRIMVEZ = 'S' THEN              -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                        V_VRITEM := C_APURACAO.VALOR;
                        V_PRIMVEZ := 'N';
                     ELSE
                        IF C_APURACAO.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                           V_VRITEM := V_VRITEM / 1;
                        ELSE
                           V_VRITEM := V_VRITEM / C_APURACAO.VALOR;
                        END IF;
                     END IF;
                  END IF;
           END LOOP;
           SELECT '8484' || SUBSTR(DESP.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
             INTO V_DSLINHA
             FROM DUAL;
              V_CONTADOR  := V_CONTADOR + 1;
              V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
              INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES
                (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
              V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
        ELSE
           FOR C_APURACAO IN
              (SELECT SUBSTR(CDORIGDEMO, 4, 3) CDORIGDEMO
                 FROM ITEMAPUCTB
                WHERE CDTIPODEMO = DESP.CDTIPODEMO
                  AND CDITEMSTRU = DESP.CDITEMSTRU
                ORDER BY CDSEGUAPUR)LOOP
                FOR C_VALORITEM IN
                (SELECT TO_NUMBER(SUBSTR(A.DSREGARQMAG, 8, 15) || ',' || SUBSTR(A.DSREGARQMAG, 23, 2)) VALOR, A.DSREGARQMAG REGISTRO
                   FROM ARQMAGNETICO A
                  WHERE NRSEQARQMAG = P_NRSEQARQMAG
                    AND SUBSTR(DSREGARQMAG, 1, 4) = '8484'
                    AND SUBSTR(DSREGARQMAG, 5, 3) = C_APURACAO.CDORIGDEMO) LOOP
                    IF DESP.IDOPERACAO = 'S' THEN            -- Realiza a soma dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF SUBSTR(C_VALORITEM.REGISTRO, 25, 2) = '+1' THEN
                          V_VRITEM := V_VRITEM + C_VALORITEM.VALOR;
                       ELSE
                          V_VRITEM := V_VRITEM + (C_VALORITEM.VALOR * -1); 
                       END IF;
                    ELSIF DESP.IDOPERACAO = 'U' THEN       -- Realiza a subtrao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN
                          V_VRITEM  := C_VALORITEM.VALOR;
                          V_PRIMVEZ := 'N';
                       ELSE
                          V_VRITEM  := V_VRITEM - C_VALORITEM.VALOR;
                       END IF;
                    ELSIF DESP.IDOPERACAO = 'M' THEN       -- Realiza a multiplicao dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN
                          V_VRITEM  := 1;
                          V_PRIMVEZ := 'N';
                       END IF;
                       V_VRITEM := V_VRITEM * C_VALORITEM.VALOR;
                    ELSIF DESP.IDOPERACAO = 'D' THEN        -- Realiza a diviso dos itens de apurao para gravar no item de estrutura dentro da tabela arqmagnetico.
                       IF V_PRIMVEZ = 'S' THEN              -- Verifica se  o primeiro item de apurao, para que no d 0 divido pelo valor do item de apurao.
                          V_VRITEM := C_VALORITEM.VALOR;
                          V_PRIMVEZ := 'N';
                       ELSE
                          IF C_VALORITEM.VALOR = 0 THEN -- Verifica se o item de apurao  nulo ou zerado, para que no d diviso por zero.
                             V_VRITEM := V_VRITEM / 1;
                          ELSE
                             V_VRITEM := V_VRITEM / C_VALORITEM.VALOR;
                          END IF;
                       END IF;
                    END IF;
                END LOOP;
           END LOOP;
           SELECT '8484' || SUBSTR(DESP.CDITEMSTRU, 2, 3)  || LPAD(REPLACE(REPLACE(REPLACE(TO_CHAR(ABS(V_VRITEM), '000000000000000.00'), '.', ','), ',', ''), ' ', ''), 17, '0') || DECODE(ABS(V_VRITEM), V_VRITEM, '+1', '-1')
             INTO V_DSLINHA
             FROM DUAL;
              V_CONTADOR  := V_CONTADOR + 1;
              V_CONTADORS := LPAD(TO_CHAR(V_CONTADOR),10,'0');
              INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES
                (V_CONTADORS, V_DSLINHA, P_NRSEQARQMAG);
              V_TOTARQUIVO := NVL(V_TOTARQUIVO,0)+1;
        END IF;
     END LOOP;
     UPDATE ARQMAGNETICO
        SET DSREGARQMAG = SUBSTR(DSREGARQMAG, 1, 24)
      WHERE NRSEQARQMAG = P_NRSEQARQMAG
        AND SUBSTR(DSREGARQMAG, 1, 4) IN ('8181', '8282', '8383', '8484');
   P_TOTALARQ := V_TOTARQUIVO;
   P_CONTADOR := V_CONTADOR;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DIMESC_CONTABIL','5.33.000'); END;
/
