/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: ATUFORN_COMPRA                                                    */
/* Tabela : PRODCOMPRA, FORPRCOMPRA, COMPRA                                   */
/*                                                                            */
/* Criao:                                                                   */
/* 22/09/2006 - Raquel Cunha                                                  */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'ATUFORN_COMPRA'   and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
DROP TRIGGER ATUFORN_COMPRA
GO

CREATE TRIGGER ATUFORN_COMPRA
ON PRODCOMPRA
FOR INSERT
AS
DECLARE @V_IDCOMANDO             VARCHAR(1);
DECLARE @V_NEW_NRCOMPRA          VARCHAR(10);
DECLARE @V_NEW_CDPRODUTO         VARCHAR(10);
DECLARE @V_FORNATENDE_CDFORNECED VARCHAR(21);
DECLARE @V_IDSITUCOMPRA          VARCHAR(1);
DECLARE @V_FORNECEDOR            VARCHAR(1);
DECLARE @V_CDFILCENTCMP          VARCHAR(4);
DECLARE @V_NEW_CDFILSOLI         VARCHAR(4);
DECLARE @V_CDARVPROD             VARCHAR(20);
BEGIN
   DECLARE C_DADOS CURSOR FOR
      SELECT
         'I' IDCOMANDO,
         NRCOMPRA,
         CDPRODUTO,
         CDFILSOLI
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_NRCOMPRA,
                                @V_NEW_CDPRODUTO,
                                @V_NEW_CDFILSOLI;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_IDCOMANDO = 'I' BEGIN
         SET @V_FORNECEDOR = 'N';
         SELECT
            @V_IDSITUCOMPRA = IDSITUCOMPRA
         FROM
            COMPRA
         WHERE
            NRCOMPRA = @V_NEW_NRCOMPRA;
         SELECT @V_CDFILCENTCMP = ISNULL(MAX(FILIAL.CDFILCENTCMP), MAX(FILIAL.CDFILIAL))
           FROM FILIAL
          WHERE FILIAL.CDFILIAL = @V_NEW_CDFILSOLI;
         IF @V_IDSITUCOMPRA <> '6' AND
            @V_IDSITUCOMPRA <> '7' BEGIN
            SELECT @V_CDARVPROD = MAX(CDARVPROD)
              FROM PRODUTO
             WHERE CDPRODUTO = @V_NEW_CDFILSOLI;
            DECLARE C_FORNATENDE CURSOR FOR
               (SELECT
               PRODFORN.CDFORNECED
            FROM
               PRODFORN,
               PRODUTO,
            (
             SELECT/*RETORNA OS FORNECEDORES QUALIFICADOS*/
                CDFORNECED
             FROM
                FORNECEDOR LEFT JOIN QUALIFICACAO
                           ON (FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF),
                PARASUPRI
             WHERE
                (PARASUPRI.CDFILIAL = @V_CDFILCENTCMP) AND
                (
                 (FORNECEDOR.CDQUALIF IS NULL) OR
                 (
                  (FORNECEDOR.CDQUALIF IS NOT NULL) AND
                  (
                   (QUALIFICACAO.IDPERCOTCMP = '1') OR
                   (QUALIFICACAO.IDPERCOTCMP = '2' AND FORNECEDOR.IDFORNAUTO = 'S')
                  ) AND
                  (
                   (PARASUPRI.IDULTIDTVALQ = 'D' AND
                    CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) <= FORNECEDOR.DTVALQUALIF) OR
                   (PARASUPRI.IDULTIDTVALQ = 'M' AND
                    CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) <= DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF) - DAY(DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF)))
                  )
                 )
                )

                UNION

             SELECT/*RETORNA OS FORNECEDORES NAO QUALIFICADOS*/
                CDFORNECED
             FROM
                FORNECEDOR,
                QUALIFICACAO,
                PARASUPRI
             WHERE
                (FORNECEDOR.CDQUALIF IS NOT NULL) AND
                (FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF) AND
                (PARASUPRI.CDFILIAL = @V_CDFILCENTCMP) AND
                (
                 (
                  (QUALIFICACAO.IDPERCOTCMP = '2' AND FORNECEDOR.IDFORNAUTO = 'N')
                 ) OR
                 (
                  (PARASUPRI.IDULTIDTVALQ = 'D' AND
                   CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > FORNECEDOR.DTVALQUALIF) OR
                  (PARASUPRI.IDULTIDTVALQ = 'M' AND
                   CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) > DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF) - DAY(DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF)))
                 )
                )
            ) FORNECEDOR
            WHERE
               PRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO AND
               PRODFORN.CDFORNECED = FORNECEDOR.CDFORNECED AND
               @V_CDARVPROD LIKE PRODUTO.CDARVPROD + '%')
            OPEN C_FORNATENDE;
            FETCH NEXT FROM C_FORNATENDE INTO @V_FORNATENDE_CDFORNECED;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_FORNECEDOR = 'S';
               UPDATE
                  FORPRCOMPRA
               SET
                  IDSITUENVFOR = IDSITUENVFOR
               WHERE
                  NRCOMPRA   = @V_NEW_NRCOMPRA            AND
                  CDFORNECED = @V_FORNATENDE_CDFORNECED;

               IF @@ROWCOUNT = 0 BEGIN

                  INSERT INTO FORPRCOMPRA
                     (NRCOMPRA, CDFORNECED, IDSITUENVFOR)
                  VALUES
                     (@V_NEW_NRCOMPRA, @V_FORNATENDE_CDFORNECED, '2');

                  UPDATE
                     COMPRA
                  SET
                     IDSITUCOMPRA = '3'
                  WHERE
                     NRCOMPRA = @V_NEW_NRCOMPRA;
               END;
            FETCH NEXT FROM C_FORNATENDE INTO @V_FORNATENDE_CDFORNECED;
            END;
            CLOSE C_FORNATENDE;
            DEALLOCATE C_FORNATENDE;
            IF @V_FORNECEDOR = 'N' BEGIN
               IF @V_IDSITUCOMPRA = '1' BEGIN
                  UPDATE
                     COMPRA
                  SET
                     IDSITUCOMPRA = '2'
                  WHERE
                     NRCOMPRA = @V_NEW_NRCOMPRA;
               END;
            END;
         END;
      END;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_NRCOMPRA,
                                @V_NEW_CDPRODUTO,
                                @V_NEW_CDFILSOLI;
   END;
   CLOSE C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUFORN_COMPRA','4.11.056';
GO

